from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Boolean, Directory, String

Music_V0_1_0 = CommandToolBuilder(tool="MUSIC", base_command=["MUSIC"], inputs=[ToolInput(tag="in_preprocess", input_type=Boolean(optional=True), prefix="-preprocess", doc=InputDocumentation(doc="[File format ('SAM'/'ELAND'/'bowtie'/'tagAlign'/'BED5'/'BED6')] [Mapped reads file path ('stdin' for piped input)] [Output directory]")), ToolInput(tag="in_sort_reads", input_type=Directory(optional=True), prefix="-sort_reads", doc=InputDocumentation(doc="[Reads directory] [Output directory]")), ToolInput(tag="in_remove_duplicates", input_type=Boolean(optional=True), prefix="-remove_duplicates", doc=InputDocumentation(doc="[Sorted reads directory] [Max # of duplicates per position] [Output directory]")), ToolInput(tag="in_get_multiscale_broad_ers", input_type=Boolean(optional=True), prefix="-get_multiscale_broad_ERs", doc=InputDocumentation(doc="[Options/Values]")), ToolInput(tag="in_get_multiscale_punctate_ers", input_type=Boolean(optional=True), prefix="-get_multiscale_punctate_ERs", doc=InputDocumentation(doc="[Options/Values]")), ToolInput(tag="in_get_tf_peaks", input_type=Boolean(optional=True), prefix="-get_TF_peaks", doc=InputDocumentation(doc="[Options/Values]")), ToolInput(tag="in_write_ms_decomposition", input_type=Boolean(optional=True), prefix="-write_MS_decomposition", doc=InputDocumentation(doc="[Options/Values]")), ToolInput(tag="in_write_log_r_signal", input_type=Boolean(optional=True), prefix="-write_logR_signal", doc=InputDocumentation(doc="[Options/Values]")), ToolInput(tag="in_get_per_win_p_vals_vs_fc", input_type=Boolean(optional=True), prefix="-get_per_win_p_vals_vs_FC", doc=InputDocumentation(doc="[Options/Values]")), ToolInput(tag="in_get_scale_spectrum", input_type=Boolean(optional=True), prefix="-get_scale_spectrum", doc=InputDocumentation(doc="[Options/Values]")), ToolInput(tag="in_get_multiscale_music", input_type=Boolean(optional=True), prefix="-get_multiscale_music", doc=InputDocumentation(doc="[Options/Values]")), ToolInput(tag="in_chip", input_type=Boolean(optional=True), prefix="-chip", doc=InputDocumentation(doc="[ChIP reads directory]")), ToolInput(tag="in_control", input_type=Boolean(optional=True), prefix="-control", doc=InputDocumentation(doc="[control reads directory]")), ToolInput(tag="in_mapp", input_type=Boolean(optional=True), prefix="-mapp", doc=InputDocumentation(doc="[multi-mapability profiles directory]")), ToolInput(tag="in_begin_l", input_type=Boolean(optional=True), prefix="-begin_l", doc=InputDocumentation(doc="[First scale smoothing window length (1000)]")), ToolInput(tag="in_end_l", input_type=Boolean(optional=True), prefix="-end_l", doc=InputDocumentation(doc="[Last scale smoothing window length (16000)]")), ToolInput(tag="in_step", input_type=Boolean(optional=True), prefix="-step", doc=InputDocumentation(doc="[Multiplicative window length step (1.5)]")), ToolInput(tag="in_l_bin", input_type=Boolean(optional=True), prefix="-l_bin", doc=InputDocumentation(doc="[Bin size in nucleotides (5)]")), ToolInput(tag="in_l_mapp", input_type=Boolean(optional=True), prefix="-l_mapp", doc=InputDocumentation(doc="[Read length of multi-mapability profiles]")), ToolInput(tag="in_mapp_thr", input_type=Boolean(optional=True), prefix="-mapp_thr", doc=InputDocumentation(doc="[Multi-mapability signal threshold used in correction (1.2)]")), ToolInput(tag="in_l_frag", input_type=Boolean(optional=True), prefix="-l_frag", doc=InputDocumentation(doc="[Fragment length (200)]")), ToolInput(tag="in_l_c", input_type=Boolean(optional=True), prefix="-l_c", doc=InputDocumentation(doc="[Mapability correction window length (2000)]")), ToolInput(tag="in_l_p", input_type=Boolean(optional=True), prefix="-l_p", doc=InputDocumentation(doc="[Normalization window length for p-value computation]")), ToolInput(tag="in_sigma", input_type=Boolean(optional=True), prefix="-sigma", doc=InputDocumentation(doc="[min(Fore/Back, Back/Fore) (.5)]")), ToolInput(tag="in_gamma", input_type=Boolean(optional=True), prefix="-gamma", doc=InputDocumentation(doc="[Min threshold for unsmoothed/smoothed (4)]")), ToolInput(tag="in_q_val", input_type=Boolean(optional=True), prefix="-q_val", doc=InputDocumentation(doc="[Maximum q-value for the reported ERs]")), ToolInput(tag="in_l_win_min", input_type=Boolean(optional=True), prefix="-l_win_min", doc=InputDocumentation(doc="[Minimum p-val window length (100)]")), ToolInput(tag="in_l_win_max", input_type=Boolean(optional=True), prefix="-l_win_max", doc=InputDocumentation(doc="[Maximum p-val window length (5000)]")), ToolInput(tag="in_l_win_step", input_type=Boolean(optional=True), prefix="-l_win_step", doc=InputDocumentation(doc="[p-val window length step (250)]")), ToolInput(tag="in_arguments", input_type=String(optional=True), position=0, doc=InputDocumentation(doc=""))], outputs=[ToolOutput(tag="out_sort_reads", output_type=Directory(optional=True), selector=InputSelector(input_to_select="in_sort_reads", type_hint=File()), doc=OutputDocumentation(doc="[Reads directory] [Output directory]"))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Music_V0_1_0().translate("wdl", allow_empty_container=True)

